import React, { Component } from 'react';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function createFormGrabber() {
  var _class, _temp;

  createFormGrabber.count++;
  return _temp = _class = /*#__PURE__*/function (_Component) {
    _inheritsLoose(FormGrabber, _Component);

    function FormGrabber(props) {
      return _Component.call(this, props) || this;
    }

    var _proto = FormGrabber.prototype;

    _proto.render = function render() {
      return /*#__PURE__*/React.createElement(React.Fragment, null, React.Children.map(this.props.children, function (child) {
        return React.cloneElement(child, {
          formgrabberid: FormGrabber.id
        });
      }));
    };

    return FormGrabber;
  }(Component), _class.id = createFormGrabber.count, _class.data = {}, _class.append = function (name, value) {
    if (!_class.data[name]) _class.data[name] = [];

    _class.data[name].push(value);
  }, _class.get = function (name) {
    if (!_class.data[name]) return undefined;
    return _class.data[name][0];
  }, _class.getAll = function (name) {
    if (!_class.data[name]) return [];
    return _class.data[name];
  }, _class.set = function (name, value) {
    if (!_class.data[name]) {
      _class.append(name, value);
    } else {
      _class.data[name][0] = value;
    }
  }, _class.setAll = function (name, values) {
    _class.data[name] = values;
  }, _class["delete"] = function (name) {
    delete _class.data[name];
  }, _class.has = function (name) {
    if (!_class.data[name]) return false;
    return true;
  }, _class.keys = function () {
    return Object.keys(_class.data);
  }, _class.walk = function (action) {
    var result = [];

    for (var i = 0; i < Object.keys(_class.data).length; i++) {
      var key = Object.keys(_class.data)[i];
      var values = _class.data[key];

      for (var j = 0; j < values.length; j++) {
        var value = values[j];
        action(key, value, result);
      }
    }

    return result;
  }, _class.values = function () {
    return _class.walk(function (key, value, result) {
      result.push(value);
    });
  }, _class.entries = function () {
    return _class.walk(function (key, value, result) {
      var item = [];
      item.push(key);
      item.push(value);
      result.push(item);
    });
  }, _class.grab = function () {
    try {
      _class.data = {};
      var all_input_elements = [];
      var all_textarea_elements = [];
      var all_select_elements = [];
      var elementsBeenTagged = document.querySelectorAll("[formgrabberid='" + _class.id + "']");

      for (var i = 0; i < elementsBeenTagged.length; i++) {
        var element = elementsBeenTagged[i];

        if (element.tagName === "INPUT") {
          all_input_elements.push(element);
        } else if (element.tagName === "TEXTAREA") {
          all_textarea_elements.push(element);
        } else if (element.tagName === "SELECT") {
          all_select_elements.push(element);
        } else {
          var temp_input_elements = element.getElementsByTagName("input");

          for (var j = 0; j < temp_input_elements.length; j++) {
            var _element = temp_input_elements[j];
            all_input_elements.push(_element);
          }

          var temp_textarea_elements = element.getElementsByTagName("textarea");

          for (var _j = 0; _j < temp_textarea_elements.length; _j++) {
            var _element2 = temp_textarea_elements[_j];
            all_textarea_elements.push(_element2);
          }

          var temp_select_elements = element.getElementsByTagName("select");

          for (var _j2 = 0; _j2 < temp_select_elements.length; _j2++) {
            var _element3 = temp_select_elements[_j2];
            all_select_elements.push(_element3);
          }
        }
      }

      for (var _i = 0; _i < all_input_elements.length; _i++) {
        var _element4 = all_input_elements[_i];

        var type = _element4.type.trim();

        switch (type) {
          case "text":
          case "password":
          case "email":
          case "url":
          case "number":
          case "range":
          case "search":
          case "hidden":
            _class.append(_element4.name, _element4.value);

            break;

          case "radio":
            if (_element4.checked) {
              _class.append(_element4.name, _element4.value);
            }

            break;

          case "checkbox":
            if (_element4.checked) {
              _class.append(_element4.name, _element4.value);
            }

            break;

          case "file":
            for (var _i2 = 0; _i2 < _element4.files.length; _i2++) {
              var file = _element4.files[_i2];

              _class.append(_element4.name, file);
            }

            break;

          default:
            break;
        }
      }

      for (var _i3 = 0; _i3 < all_textarea_elements.length; _i3++) {
        var _element5 = all_textarea_elements[_i3];

        _class.append(_element5.name, _element5.value);
      }

      for (var _i4 = 0; _i4 < all_select_elements.length; _i4++) {
        var _element6 = all_select_elements[_i4];
        var options = _element6.options;

        for (var _i5 = 0; _i5 < options.length; _i5++) {
          var option = options[_i5];

          if (option.selected) {
            _class.append(_element6.name, option.value);
          }
        }
      }
    } catch (error) {
      console.error(error);
      throw new Error("Maybe at least one form control hasn't got attribute 'name' or 'value'");
    }
  }, _class.toCommonObject = function () {
    var result = {};

    for (var i = 0; i < _class.keys().length; i++) {
      var key = _class.keys()[i];

      result[key] = _class.get(key);
    }

    return result;
  }, _class.toURLSearchParams = function () {
    var result = new URLSearchParams();

    for (var i = 0; i < _class.entries().length; i++) {
      var element = _class.entries()[i];

      result.append(element[0], element[1]);
    }

    return result;
  }, _class.toFormData = function () {
    var formData = new FormData();

    for (var i = 0; i < _class.entries().length; i++) {
      var element = _class.entries()[i];

      if (element[1].name) {
        formData.append(element[0], element[1], element[1].name);
      } else {
        formData.append(element[0], element[1]);
      }
    }

    return formData;
  }, _temp;
}

createFormGrabber.count = 0;

export default createFormGrabber;
//# sourceMappingURL=index.modern.js.map
